# FlexAutoML 🛠️

FlexAutoML is a comprehensive, end-to-end solution designed to streamline your machine learning pipeline tasks. Unlike
traditional AutoML tools, which can often act as a "black box," FlexAutoML offers unparalleled flexibility. This enables
users to combine various machine learning functions according to their specific needs.

## Unique Selling Points 🎯

### High Level of Customizability 🎛️

The main differentiator between Machine Learning Toolbox and existing AutoML tools is the level of control it offers.
You can mix and match various preprocessing and machine learning algorithms to tailor-fit your specific problem.

## Features 💡

- **Categorical Encoding**: Efficiently convert categorical variables into a machine-readable format.

- **Feature Construction**: Create new features, like frequency-based features, to improve your model's predictive
  power.

- **Feature Normalization**: Standardize your dataset's features.

- **Feature Selection with LightGBM**: Choose the most impactful features based on LightGBM's feature importance scores.

- **Hyperparameter Optimization**: Automate the search for optimal hyperparameters for LightGBM and CatBoost.

- **Model Training**: Train your model with the best hyperparameters.

- **Ensemble Prediction**: Combine multiple models to create more robust predictions.

## Example Usage 📖

`breast_cancer_demo.py` is a quick code example to get you started.

## How to Install 📦

```bash
pip install FlexAutoML
```